

#include "ot4xb.ch"
//----------------------------------------------------------------------------------------------------------------------
#xtranslate _assert_m_(<b>,<n>,<cc>) => ;
             if !(<b>) ;
            ;  TlsStackPush(Error():New());
            ;  TlsStackTop():severity := 2;
            ;  TlsStackTop():description := <cc> ;
            ;  TlsStackTop():gencode     := 0    ;
            ;  TlsStackTop():subcode     := <n>  ;
            ;  TlsStackTop():subsystem   := ::ClassName() ;
            ;  TlsStackTop():operation   := ::ProcName()  ;
            ;  Eval(ErrorBlock(),TlsStackPop()) ;
            ;end
//----------------------------------------------------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_uuidof()  => UuidFromString("2E9196BF-13BA-4DD4-91CA-6C571F281495")
#xtranslate IServerXMLHTTPRequest_clsid()   => UuidFromString("AFB40FFD-B609-40A3-9828-F88BBE11E4E3")
//----------------------------------------------------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_QueryInterface( <pt>, [<params,...>])      => ;
            IFpQCall( 0,"__sl__sl__pt_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_AddRef( <pt>)                              => ;
            IFpQCall( 1,"__sl__sl",<pt>)
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_Release(<pt>)                              => ;
            IFpQCall( 2,"__sl__sl",<pt>)
// ---------------------------------------------------------------------------
// Skip IDispatch methods
///#xtranslate IServerXMLHTTPRequest_GetTypeInfoCount(<pt>, [<params,...>])     => ;
///            IFpQCall( 3,"__sl__sl_@sl",<pt> [,<params>] )
///// ---------------------------------------------------------------------------
///#xtranslate IServerXMLHTTPRequest_GetTypeInfo(<pt>, [<params,...>])          => ;
///            IFpQCall( 4,"__sl__sl__sl__sl_@sl",<pt> [,<params>] )
///// ---------------------------------------------------------------------------
///#xtranslate IServerXMLHTTPRequest_GetIDsOfNames(<pt>, [<params,...>])        => ;
///            IFpQCall( 5,"__sl__sl__pt__pt__sl__sl__pt",<pt> [,<params>] )
///// ---------------------------------------------------------------------------
///#xtranslate IServerXMLHTTPRequest_Invoke(<pt>, [<params,...>])               => ;
///            IFpQCall( 6,"__sl__sl__sl__pt__sl__us__pt__pt__pt_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_open(<pt>, [<params,...>])                 => ;
            IFpQCall( 7,"__sl__sl__pt__pt__vt__vt__vt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_setRequestHeader(<pt>, [<params,...>])     => ;
            IFpQCall( 8,"__sl__sl__pt__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_getResponseHeader(<pt>,[<params,...>])     => ;
            IFpQCall( 9,"__sl__sl__pt__@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_getAllResponseHeaders(<pt>,[<params,...>]) => ;
            IFpQCall(10,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_send(<pt>,[<params,...>])                  => ;
            IFpQCall(11,"__sl__sl__vt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_abort(<pt>)                => ;
            IFpQCall(12,"__sl__sl",<pt>)
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_status(<pt>,[<params,...>])            => ;
            IFpQCall(13,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_statusText(<pt>, [<params,...>])       => ;
            IFpQCall(14,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_responseXML(<pt>, [<params,...>])      => ;
            IFpQCall(15,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_responseText(<pt>, [<params,...>])     => ;
            IFpQCall(16,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_responseBody(<pt>, [<params,...>])     => ;
            IFpQCall(17,"__sl__sl__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_responseStream(<pt>, [<params,...>])   => ;
            IFpQCall(18,"__sl__sl__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_get_readyState(<pt>, [<params,...>])       => ;
            IFpQCall(19,"__sl__sl_@sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
// onreadystatechange is intended for scripting. Skiped
//#xtranslate IServerXMLHTTPRequest_put_onreadystatechange(<pt>,[<params,...>])=> ;
//            IFpQCall(20,"__sl__sl__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_setTimeouts(<pt>, [<params,...>])          => ;
            IFpQCall(21,"__sl__sl__sl__sl__sl__sl",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_waitForResponse( <pt>, [<params,...>])     => ;
            IFpQCall(22,"__sl__sl__vt__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_getOption( <pt>, [<params,...>])           => ;
            IFpQCall(23,"__sl__sl__sl__pt",<pt> [,<params>] )
// ---------------------------------------------------------------------------
#xtranslate IServerXMLHTTPRequest_setOption( <pt>, [<params,...>])           => ;
            IFpQCall(24,"__sl__sl__sl__vt",<pt> [,<params>] )
//----------------------------------------------------------------------------------------------------------------------
CLASS TServerXMLHTTPRequest
EXPORTED:
VAR _pi_
VAR nLastError
       // ---------------------------------------------------------------------------------
INLINE CLASS METHOD uuidof() ; return IServerXMLHTTPRequest_uuidof()
INLINE CLASS METHOD clsid()  ; return IServerXMLHTTPRequest_clsid()
       // ---------------------------------------------------------------------------------
INLINE METHOD init()
       local p := 0
       ::_pi_ := 0
       ::nLastError := @ole32:CoCreateInstance(::clsid(),0,23,::uuidof(),@p)
        if ::nLastError == 0 ; ::_pi_ := p ; end
        return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD QueryInterface(iid,p) // HRESULT
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_QueryInterface(::_pi_,iid,@p)
       return ::nLastError
       // ---------------------------------------------------------------------------------
INLINE METHOD AddRef() // HRESULT
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_AddRef(::_pi_)
       return ::nLastError
       // ---------------------------------------------------------------------------------
INLINE METHOD Release() // HRESULT
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_Release(::_pi_)
       return ::nLastError
       // ---------------------------------------------------------------------------------
INLINE METHOD Open(cMethod,cUrl,lAsync,cUser,cPwd) // lOk
       local bsMethod,bsUrl
       local vAsync   := __vtMissing__
       local vUser    := __vtMissing__
       local vPwd     := __vtMissing__
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       DEFAULT cMethod := "GET"
       DEFAULT cUrl    := ""
       bsMethod := @ot4xb:str2bstr(cMethod,-1)
       bsUrl    := @ot4xb:str2bstr(cUrl,-1)
       if( Valtype(lAsync) == "L" ) ; @ot4xb:_variant_t_Set_BOOL(@vAsync,lAsync) ; end
       if( Valtype(cUser ) == "C" ) ; @ot4xb:_variant_t_SetString(@vUser,cUser ) ; end
       if( Valtype(cPwd  ) == "C" ) ; @ot4xb:_variant_t_SetString(@vPwd ,cPwd  ) ; end
       ::nLastError := IServerXMLHTTPRequest_open( ::_pi_,bsMethod,bsUrl,vAsync,vUser,vPwd)
       @oleaut32:SysFreeString(bsMethod)
       @oleaut32:SysFreeString(bsUrl)
       @ot4xb:_variant_t_Clear( @vAsync )
       @ot4xb:_variant_t_Clear( @vUser  )
       @ot4xb:_variant_t_Clear( @vPwd   )
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE METHOD SetRequestHeader( cEntry ,  cVal )  // lOk
       local bsEntry,bsVal
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       _assert_m_( Valtype( cEntry) == "C",1, "Bad Param cEntry")
       DEFAULT cVal := ""
       _assert_m_( Valtype(cVal) == "C",1, "Bad Param cVal")
       bsEntry := @ot4xb:str2bstr(cEntry,-1)
       bsVal   := @ot4xb:str2bstr(cVal  ,-1)
       ::nLastError := IServerXMLHTTPRequest_setRequestHeader(::_pi_,bsEntry,bsVal)
       @oleaut32:SysFreeString(bsEntry)
       @oleaut32:SysFreeString(bsVal)
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE METHOD GetResponseHeader( cEntry )  // cValue | NIL
       local bsEntry,bsVal
       local cVal := NIL
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       _assert_m_( Valtype( cEntry) == "C",1, "Bad Param cEntry")
       bsEntry := @ot4xb:str2bstr(cEntry,-1)
       bsVal   := 0
       ::nLastError := IServerXMLHTTPRequest_getResponseHeader(::_pi_,bsEntry,@bsVal)
       if( bsVal != 0 ) ; cVal := PeekStr(bsVal,,-3) ; end
       @oleaut32:SysFreeString(bsEntry)
       @oleaut32:SysFreeString(bsVal)
       return cVal
       // ---------------------------------------------------------------------------------
INLINE METHOD GetAllResponseHeaders()  // -> cHead | NIL
       local bs
       local cc := NIL
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       bs := 0
       ::nLastError := IServerXMLHTTPRequest_getAllResponseHeaders(::_pi_,@bs)
       if( bs != 0 ) ; cc := PeekStr(bs,,-3) ; end
       @oleaut32:SysFreeString(bs)
       return cc
       // ---------------------------------------------------------------------------------
       // For common ussage use ::Send() instead.
       // Send the request using a variant
INLINE METHOD vSend( vBody )  // -> lOk
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_send(::_pi_,vBody)
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE METHOD Send( cBody )  // -> lOk
       local vBody :=  NIL
       local lOk := .F.
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       DEFAULT cBody := ""
       if( Valtype(cBody) == "C" )
          vBody := ChrR(0,16)
          @ot4xb:_variant_t_SetString(@vBody,cBody)
       end
       lOk := ::vSend( vBody )
       if vBody != NIL
          @ot4xb:_variant_t_Clear( @vBody )
       end
       return lOk
       // ---------------------------------------------------------------------------------
INLINE METHOD Abort() // lOk
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_abort(::_pi_)
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD status() // nStatus | NIL  READONLY
       local nn := 0
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_status(::_pi_,@nn)
       if ::nLastError == 0 ; return nn ; end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD statusText() // cStatusText | NIL ( READONLY )
       local bs := 0
       local cc := NIL
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_statusText(::_pi_,@bs)
       if( bs != 0 ) ; cc := PeekStr(bs,,-3) ; end
       @oleaut32:SysFreeString(bs)
       return cc
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD responseXML() // -> oIDispatch | NIL
       local pd := 0
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_responseXML(::_pi_,@pd)
       if ::nLastError == 0
          return ot4xb_IDispatch():New():_link_(pd,.F.)
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD responseText() // responseText | NIL ( READONLY )
       local bs := 0
       local cc := NIL
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_responseText(::_pi_,@bs)
       if( bs != 0 ) ; cc := PeekStr(bs,,-3) ; end
       @oleaut32:SysFreeString(bs)
       return cc
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD responseBody()
       local v := ChrR(0,16)
       local cc := NIL
       local p,cb
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_responseBody(::_pi_,@v)
       if( ::nLastError == 0 )
          cb := 0 ; p := @ot4xb:_variant_t_VT_UI1Array2Str(v,@cb)
          if !Empty(p)
             cc := PeekStr(p,0,cb)
             _xfree(p)
          end
       end
       @ot4xb:_variant_t_Clear( @v )
       return cc
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD responseStream()
       local v := ChrR(0,16)
       local p := 0
       local oUnk := NIL
       local oStm := NIL
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_responseStream(::_pi_,@v)
       if( ::nLastError == 0 )
          p := @ot4xb:_variant_t_GetIUnknow(v)
          if(!Empty(p))
             oUnk := ot4xb_IUnknow():New():_link_(p,.F.)
             p := 0
             oUnk:QueryInterface(IStream.uuidof(),@p)
             oUnk:Release()
             if(!Empty(p))
                oUnk := ot4xb_IStream():New():_link_(p,.F.)
             end
          end
       end
       @ot4xb:_variant_t_Clear( @v )
       return oStm
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD readyState()
       local nn := 0
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_get_readyState(::_pi_,@nn)
       if( ::nLastError == 0 ) ; return nn ; end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD SetTimeouts(nResolve,nConnect,nSend,nReceive)
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_setTimeouts(::_pi_,nResolve,nConnect,nSend,nReceive)
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE METHOD WaitForResponse( nSeconds )
       local vSeconds := __vtMissing__
       local v   := ChrR(0,16)
       local r   := .F.
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       if( nSeconds != NIL ) ; @ot4xb:_variant_t_Set_I4(@vSeconds,nSeconds) ; end
       ::nLastError := IServerXMLHTTPRequest_waitForResponse(::_pi_,@vSeconds,@v)
       if( @ot4xb:_variant_t_Get_BOOL(v,@r) == 0 ); r := NIL ; end
       @ot4xb:_variant_t_Clear( @vSeconds )
       @ot4xb:_variant_t_Clear( @v )
       return r
       // ---------------------------------------------------------------------------------
INLINE METHOD GetOption( nOption , v ) // -> vVal ( variant )
       _assert_m_( Valtype(v) == "C",1, "Bad Param")
       _assert_m_( Len(v) == 16 ,1, "Bad Param")
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_getOption(::_pi_,nOption,@v)
       return ( ::nLastError == 0 )
       // ---------------------------------------------------------------------------------
INLINE METHOD SetOption( nOption , vVal )
       _assert_m_( !Empty(::_pi_),-2, "Object not properly initialized")
       ::nLastError := IServerXMLHTTPRequest_setOption(::_pi_,nOption,vVal)
       return ( ::nLastError = 0 )
       // ---------------------------------------------------------------------------------
INLINE ACCESS METHOD cUrl
       local v := ChrR(0,16)
       local cUrl := NIL
       local cb   := 0
       local p    := 0
       if ::GetOption(-1 , @v )
          p := @ot4xb:_variant_t_GetString(v,@cb)
          if( p != 0 )
             cUrl := PeekStr(p,0,cb)
             _xfree(p)
          end
       end
       @ot4xb:_variant_t_Clear( @v )
       return cUrl
       // ---------------------------------------------------------------------------------




       // ---------------------------------------------------------------------------------
ENDCLASS
//----------------------------------------------------------------------------------------------------------------------

